'******************************************************************************
'                            TR_LEDS.BAS
'                            25.11.2006 
'
'                  (c) Birger Tpelmann kw41@gmx.de
'******************************************************************************
$IF 0 ' Kommentare in Schwarz auf weiss

TROLL-Praxis 2. Vorhaben:

Jetzt wollen wir mal ein bisschen mehr Praxis haben und die LEDs blinkern lassen.
Vielleicht schaffen wir mit dem il_Troll ja auch mal etwas wie www.blinkenlights.de ;-)
Und ausserdem soll auch mal die Analogeingabe getestet werden. 
Das mit den Tasten (siehe TR_DEFS) versuchen wir spter nochmal.
'AUFGABE:
Die 9 LEDs sollen in einer vorgegeben Abfolge ein- und ausschalten (Lauflicht).
Die Wiederholgeschwindigkeit soll ber ein Poti (fast) stufenlos verstellbar sein.
'LSUNG:
Die Abfolge der LED Leuchtmuster wird in einer DATA -Zeile vorgegeben.
Am Anfang der DATA -Zeile steht die Anzahl der auszugebenden Leuchtmuster.
Die Ausgabe der Leuchtmuster erfolgt in einer FOR NEXT Schleife.
Die einzelnen Ausgabeschritte werden durch WAIT verzgert; Die Lnge des WAIT 
wird vom POTIL eingelesen.
'ERGNZUNG:
1.) Als kleiner Gag sozusagen soll(te) das LED-Ausgabemuster mit SEROUT an den Speaker
ausgegeben und somit ein Tickern und Brummen erzeugt werden. Der unerwnschte
und unerklrliche Nebeneffekt ist, das sich die LEDM am Nachbarport nicht mehr
abschalten lsst; -> SEROUT an RC,6 bewirkt ein HIGH an RC,7 ?!
LOFREQ funktioniert zwar, aber das Ergebnis ist nicht so witzig.
2.) Eine zweite Analogwarteschleife mit POTIM in der Hauptroutine regelt die 
Pausenlnge zwischen den Ausgabezyklen.
3.) Und noch ein anderes Muster, und noch eins und dann noch eins...
Zwischen den verschiedenen Ausgabemustern mu im SUB "Lichtorgel" mit Hilfe
der Kommentarzeilen ausgewhlt werden.  

$ENDIF
'
' Die Defines des Troll auf dem Testboard 1 ersparen hier das Blttern im Buch
'
'$DEBUG
$TROFF
         DEFINE device iL_Troll        
' Die Defines des Troll und seiner Pins ersparen hier das Blttern im Buch
         DEFINE POTIL   = RA,0         ' P31 (links) an Analogeingang 1
         DEFINE POTIM   = RA,1         ' P32 (mitte) an Analogeingang 2
         DEFINE EINGANG = RA,2         ' K31:7-8 freier Digitaler Eingang
         DEFINE POTIR   = RA,3         ' P31 (rechts) an Analogeingang 3
         DEFINE TASTER  = RA,4         ' S33 Taster rechts
         
         DEFINE LEDNW   = RB,0         ' LED in Himmelsrichtungen bezeichnet
         DEFINE LEDN    = RB,1         '
         DEFINE LEDNO   = RB,2         ' NW | N | NO
         DEFINE LEDO    = RB,3         ' ---+---+---
         DEFINE LEDSO   = RB,4         '  W | M | O
         DEFINE LEDS    = RB,5         ' ---+---+---
         DEFINE LEDSW   = RB,6         ' SW | S | SO
         DEFINE LEDW    = RB,7
         
         DEFINE DIP1    = RC,0         ' DIP-Switch :1
         DEFINE DIP2    = RC,1         ' DIP-Switch :2
         DEFINE DIP3    = RC,2         ' DIP-Switch :3
         DEFINE DIP4    = RC,3         ' DIP-Switch :4
         DEFINE TASTEL  = RC,4         ' S51 Taster links
         DEFINE TASTEM  = RC,5         ' S52 Taster Mitte
         DEFINE LAUTSP  = RC,6         ' Lautsprecher
         DEFINE LEDM    = RC,7         ' Mittlere LED
'
' VAR -------------- Variablen -------------------------------------
'
         DEFINE mpv     = AUTO AS BYTE ' Multi Purpose Variable
         DEFINE ia      = AUTO AS BYTE ' Laufvariable Anfang
         DEFINE ib      = AUTO AS BYTE ' Laufvariable Port B
         DEFINE ic      = AUTO AS BYTE ' Laufvariable Port C
         DEFINE ie      = AUTO AS BYTE ' Laufvariable Ende
         DEFINE speed   = AUTO AS BYTE ' Zwischenspeicher fr WAIT     
'
' INIT ------------ Programmeinsprung nach Kaltstart ---------------
'
cold: 
         TRIS rb,%00000000             ' E/A-Initialisierung fr
         TRIS rc,%00111111             ' Testboard Hardware
         LET  rb = %10101010           ' Ausgabepins Grundstellung
         RES  LEDM
'         
' MAIN ------------ Hauptschleife E - V - A -------------------------
'
main:
'         GOSUB Eingabe
'         GOSUB Verarbeitung
'         GOSUB Ausgabe
         GOSUB Lichtorgel         
         ADINP 1,mpv                   ' Analogeingabe
         WAIT  mpv                     ' Schwarteleife
         GOTO main
'
' SUB --------------- Eingabe ---------------------------------------
'
Eingabe:
         RETURN
'
' SUB --------------- Verarbeitung ----------------------------------
'
Verarbeitung:
         RETURN
'
' SUB --------------- Ausgabe ---------------------------------------
'
Ausgabe:
         RETURN
'
' SUB ------------ Lichtorgel ---------------------------------------         
' Verschiedene Ausgabemuster an den LED-Wrfel ausgeben.
Lichtorgel:
'         RESTORE DsternR              ' Bitte whlen Sie Ihr Programm
'         RESTORE DsternL
'         RESTORE Dstern2
'         RESTORE DBalkn1
'         RESTORE DBalkn2
         RESTORE DBalkn3
'         RESTORE DWurfel
'         
         READDATA ie                   ' Anzahl der Datenstzen
         FOR ia = 1 TO ie
           READDATA ib,ic
'           serout RC,6,2400,ib         ' nicht geplant, aber witzig
           LOFREQ RC,6,160,12
           OUTPUT RB,ib
'          IF ic = 0 THEN RES RC,7 ELSE SET RC,7
           IF ic = 0 THEN RES LEDM ELSE SET LEDM
           ADINP 0,speed               ' Analogeingabe
           WAIT speed                  ' Schwarteleife
           WAIT 80
         NEXT ia 
         RETURN
'
' DAT --------------- DATA Zeilen -----------------------------------
'
' Datazeilen fr Lichtorgel:
' 1. Byte = Anzahl der folgende Ausgabemuster / Durchlauf
' 2.,4...Byte = Ausgabemuster fr die ueren LEDs
' 3.,5...Byte = Ein-/Ausschalter fr mittlere LED
DsternR:  DATA  4, $11,1 $22,1 $44,1 $88,1
DsternL:  DATA  4, $11,1 $88,1 $44,1 $22,1
Dstern2:  DATA 10, $11,1 $22,0 $44,1 $88,0 $0,1 $11,0 $22,1 $44,0 $88,1 255,0
DBalkn1:  DATA  8, $10,0 $30,0 $70,0 $B0,0 $11,1 $1A,0 $1C,0 $18,0
DBalkn2:  DATA 16, $70,0 $B0,0 $11,1 $1A,0 $1C,0 $2C,0 $44,1 $86,0 
          DATA     $07,0 $0B,0 $11,1 $A1,0 $C1,0 $C2,0 $44,1 $68,0
DBalkn3:  DATA 12, $07,0 $88,1 $70,0 $88,1 $11,1 $22,1 $1C,0 $22,1 
          DATA     $C1,0 $22,1 $44,1 $88,1
Dwurfel:  DATA  6,   0,1 $11,0 $11,1 $55,0 $55,1 $DD,0
          DATA 0,0

'
' END --------------- Ende Gelnde ----------------------------------
'
         END         