'******************************************************************************
'                            TR_TASTb.BAS
'              25.11.2006 b (Der Wurm war nicht alleine drin / Debugger Praxis)
'             ...und wer keinen Bock zum Suchen hat guckt weiter in TR_TASTc
'
' Der Wurm in Tasta (oder auch Konstanten sind variabel):
' Konstanten sollten auch dem Compiler als solche angezeigt werden.
' Die Konstanten TASTMIN..TASDIF wurden vom Compiler als Variablen bersetzt.
' Die Variable TASTDIF enthielt bei mir (zufllig ?) nix ($00).
'
'                  (c) Birger Tpelmann kw41@gmx.de
'******************************************************************************
$IF 0 ' Kommentare in Schwarz auf weiss

TROLL-Praxis 3. Vorhaben: Tasten im Griff

Jetzt widmen wir uns mal den Tasten: 
'AUFGABE: 
In einer allgemeinen Tastenroutine (SUB Eingabe) soll ber die drei Tasten des 
Testboards eine Byte Variable wie folgt beeinflusst werden:
Taste links (RC,4) verringert die Variable bis zu einem Minimalwert (TASTMIN);
Taste rechts (RA,4) erhht die Variable bis zu einem Maximalwert (TASTMAX);
Bei jedem Tastendruck wird die Variable um einen vorgegeben Wert verndert (TASTDIF);
Taste mitte (RC,5) setzt die Variable auf einen vorgegebenen Wert (TASTMID);
Es soll keine Tastenwiederholfunktion geben; Auch wenn die Taste dauernd gedrckt 
bleibt, wird pro Tastendruck nur einmal die zugehrige Aktion ausgefhrt.
Jede Taste hat einen fr jeden neuen Tastendruck gebildeten Tastenimpulsmerker, 
der nur whrend eines Programmdurchlaufs - zwischen zwei Tastenabfragen - aktiv ist.

'FUNKTIONSKONTROLLE:
Die Tasten werden auf den LED-Wrfel "geschaltet":
Die oberen LEDs (die Nordlichter) werden mit jedem Tastendruck ge TOGGLE d 
(Stromstoschalter); Die mittleren LEDs (W M O) TOGGLE n solange eine Taste
gedrckt wird.  
Die drei unteren LEDs signalisieren Wertnderungen in der Byte Variablen;
LEDS an = keine nderung, LED SW = Wert verringert, LED SO = Wert erhht.

'LSUNG(sansatz): siehe unten...
In einer Variablen (Flankenmerker) wird sich der letzte Zustand der Tasten gemerkt.
IF Taste gedrckt THEN 
   IF Flankenmerker THEN          ' Taste noch gedrckt
      Impulsmerker lschen
   ELSE                           ' neuer Tastendruck
      Flankenmerker setzen
      Impulsmerker setzen
      Tastenwert bearbeiten
ELSE                              ' keine Taste gedrckt
  Flankenmerker lschen
  Impulsmerker lschen
      

'BEOBACHTUNG:
Die Statusleuchten tun jetzt auch richtig bis ...
Mehrmals Taste rechts drcken, die LED fr "grer" blitzt bei jedem Tastendruck auf 
und dann pltzlich die LED fr "kleiner" ?!
Was ist denn jetzt schon wieder ? (Ich sag nix mehr ohne Debugger..)
'Hinweise: 
Zum Debuggen das $DEBUG dekommentieren.
$TRON und $TROFF stehen schon an der richtigen Stelle fr die Beobachtung im Debugger

$ENDIF
'
' Die Defines des Troll auf dem Testboard 1 ersparen hier das Blttern im Buch
'
$DEBUG
$TROFF
         DEFINE device iL_Troll        
'         DEFINE POTIL   = RA,0         ' P31 (links) an Analogeingang 1
'         DEFINE POTIM   = RA,1         ' P32 (mitte) an Analogeingang 2
'         DEFINE EINGANG = RA,2         ' K31:7-8 freier Digitaler Eingang
'         DEFINE POTIR   = RA,3         ' P31 (rechts) an Analogeingang 3
         DEFINE TASTER  = RA,4         ' S33 Taster rechts
         
         DEFINE LEDNW   = RB,0         ' LED in Himmelsrichtungen bezeichnet
         DEFINE LEDN    = RB,1         '
         DEFINE LEDNO   = RB,2         ' NW | N | NO
         DEFINE LEDO    = RB,3         ' ---+---+---
         DEFINE LEDSO   = RB,4         '  W | M | O
         DEFINE LEDS    = RB,5         ' ---+---+---
         DEFINE LEDSW   = RB,6         ' SW | S | SO
         DEFINE LEDW    = RB,7
         
'         DEFINE DIP1    = RC,0         ' DIP-Switch :1
'         DEFINE DIP2    = RC,1         ' DIP-Switch :2
'         DEFINE DIP3    = RC,2         ' DIP-Switch :3
'         DEFINE DIP4    = RC,3         ' DIP-Switch :4
         DEFINE TASTEL  = RC,4         ' S51 Taster links
         DEFINE TASTEM  = RC,5         ' S52 Taster Mitte
         DEFINE LAUTSP  = RC,6         ' Lautsprecher
         DEFINE LEDM    = RC,7         ' Mittlere LED
'
' VAR -------------- Variablen -------------------------------------
'
'        und defines auch, alles fr die Tastaratur
         DEFINE flanken = AUTO AS BYTE ' Flanken- und Impulsmerker fr Tastenabfrage
         DEFINE TASTIL  = flanken,4    ' Taste L gedrckt (Impuls)
         DEFINE TASTIM  = flanken,5    ' Taste M gedrckt (Impuls) 
         DEFINE TASTIR  = flanken,6    ' Taste R gedrckt (Impuls)
         DEFINE tastvar = AUTO AS BYTE ' Mit Tasten ausgewhlter Wert
'############################################################################# Korrektur 
         DEFINE TASTMIN = 100 AS CONST ' Minimaler Tastenwert
         DEFINE TASTMID = 172 AS CONST ' Normaler Tastenwert
         DEFINE TASTMAX = 255 AS CONST ' Maximaler Tastenwert
         DEFINE TASTDIF = 25  AS CONST ' Wertnderung / Tastendruck         
'#############################################################################
         DEFINE tasttmp = AUTO AS BYTE ' Zwischenspeicher letzter Tastenwert
         DEFINE mpv     = AUTO AS BYTE ' Multi Purpose Variable
'
' INIT ------------ Programmeinsprung nach Kaltstart ---------------
'
cold: 
         TRIS rb,%00000000             ' E/A-Initialisierung fr
         TRIS rc,%00111111             ' Testboard Hardware
         LET  rb = %10101010           ' Ausgabepins Grundstellung
         RES  LEDM
'         
' MAIN ------------ Hauptschleife E - V - A -------------------------
'
main:
         GOSUB Tasten                  ' Eingabe
'         GOSUB TuWas                  ' Verarbeitung
         GOSUB Ledanzeige              ' Ausgabe
         
         WAIT  100
         GOTO main
'
' SUB --------------- Eingabe ---------------------------------------
'
Tasten:  ' Tastenabfrage und Flanken- und Impulsmerker Reset
         IF TASTEL = 0 THEN GOSUB TastL1 ELSE LET flanken = flanken OR $11
         IF TASTEM = 0 THEN GOSUB TastM1 ELSE LET flanken = flanken OR $22
         IF TASTER = 0 THEN GOSUB TastR1 ELSE LET flanken = flanken OR $44
         RETURN
TastX:   ' X wie Exit aus der Routine      
'         SEROUT LAUTSP,2400,$55        ' Tastenklick
         WAIT 20                       ' Entprellverzgerung
         RETURN
TastL1:  ' Taste links Flanke erkennen 
         IF flanken,0 = 0 THEN GOTO TastL2       ' Taste noch gedrckt = nix tun
         LET flanken = flanken AND %11101110     ' Tastendruck merken
$TRON
         IF tastvar >= TASTMIN + TASTDIF THEN LET tastvar = tastvar - TASTDIF
         GOTO TastX
$TROFF
TastL2:  SET TASTIL          ' Reset Impulsmerker
         RETURN
         
TastM1:  ' Taste mitte Flanke erkennen 
         IF flanken,1 = 0 THEN GOTO TastM2       ' Taste noch gedrckt = nix tun
         LET flanken = flanken AND %11011101     ' Tastendruck merken
         LET tastvar = TASTMID                   ' Tastenvariable auf Standardwert
         GOTO TastX
TastM2:  SET TASTIM          ' Reset Impulsmerker
         RETURN

TastR1:  ' Taste Rechts Flanke erkennen 
         IF flanken,2 = 0 THEN GOTO TastR2       ' Taste noch gedrckt = nix tun
         LET flanken = flanken AND %10111011     ' Tastendruck merken
         ' Tastenvariable erhhen WENN noch Platz nach oben ist
$TRON
         IF tastvar <= TASTMAX - TASTDIF THEN LET tastvar = tastvar + TASTDIF
         GOTO TastX
$TROFF
TastR2:  SET TASTIR          ' Reset Impulsmerker
         RETURN
         
         
'
' SUB --------------------- Leds --------------------------------------------
'
Ledanzeige:
         ' 3 x Stromstoschalter
         IF TASTIL = 0 THEN TOGGLE LEDNW
         IF TASTIM = 0 THEN TOGGLE LEDN
         IF TASTIR = 0 THEN TOGGLE LEDNO
         ' 3 x Blinklicht solange Taste gedrckt
         IF Flanken,0 = 0 THEN TOGGLE LEDW
         IF Flanken,1 = 0 THEN TOGGLE LEDM
         IF Flanken,2 = 0 THEN TOGGLE LEDO
         ' Tastvar auswertung
         IF Tastvar > Tasttmp THEN GOTO LedsG
         IF Tastvar < Tasttmp THEN GOTO LedsK
         RES LEDSW
         SET LEDS
         RES LEDSO
         GOTO LedsX
LedsG:
         RES LEDSW
         RES LEDS
         SET LEDSO
         GOTO LedsX
LedsK:
         SET LEDSW
         RES LEDS
         RES LEDSO
LedsX:
         LET Tasttmp = Tastvar
         RETURN
'
' DAT --------------- DATA Zeilen -----------------------------------
'

'
' END --------------- Ende Gelnde ----------------------------------
'
         END         